//          AUTHOR ROGANOV G.V. (, )

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXClass, DXDraws, ExtCtrls, StdCtrls, Label3DF, MyImageList,
  SpeedButtonCep, MyImage, DXSounds,  MyCheckBox, inifiles;

type
  TForm1 = class(TForm)
    DXDraw1: TDXDraw;
    DXTimer1: TDXTimer;
    Label3DF1: TLabel3DF;
    CountLabel: TLabel3DF;
    SpeedButtonCep1: TSpeedButtonCep;
    ImageList1: TMyImageList;
    NextFigureImage: TMyImage;
    SpeedButtonCep2: TSpeedButtonCep;
    KBTimer: TTimer;
    CLTimer: TTimer;
    LinesLabelname: TLabel3DF;
    LinesLabel: TLabel3DF;
    Label3DF4: TLabel3DF;
    LeverLabel: TLabel3DF;
    DXSound1: TDXSound;
    SoundCB: TMyCheckBox;
    DXWaveList1: TDXWaveList;
    SpeedButtonCep3: TSpeedButtonCep;
    BGlist: TMyImageList;
    BrickList: TMyImageList;
    SpeedButtonCep4: TSpeedButtonCep;
    SpeedButtonCep5: TSpeedButtonCep;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Label3DF2: TLabel3DF;
    RecordLabel: TLabel3DF;
    procedure DXTimer1Activate(Sender: TObject);
    Procedure Draw;
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButtonCep1Click(Sender: TObject);
    procedure SpeedButtonCep2Click(Sender: TObject);
    Procedure SetBmpNextFigure;
    Procedure MoveFigure;
    Procedure KbMoveFigure;
    Procedure SetNewFigure;
    Procedure TurnFugure;
    Procedure TestMatrix;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure KBTimerTimer(Sender: TObject);
    procedure CLTimerTimer(Sender: TObject);
    procedure SpeedButtonCep3Click(Sender: TObject);
    procedure SpeedButtonCep4Click(Sender: TObject);
    procedure SpeedButtonCep5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    Procedure GetRem;
  private
    { Private declarations }
  public
    RemBmp:Tbitmap;
  end;

type int = -2..2;

type TFigureIndex = packed record
     Fig : 1..7;
     Ras : 1..4;
     X,Y:byte; //in matrix
end;

Const Figure: array [1..7,1..4,1..6] of int =
      (((0,1,1,1,1,0),(0,1,1,1,1,0),(0,1,1,1,1,0),(0,1,1,1,1,0)),
       ((-1,0,1,0,2,0),(0,-1,0,1,0,2),(-1,0,1,0,2,0),(0,-1,0,1,0,2)),
       ((0,-1,1,-1,0,1),(-1,0,1,0,1,1),(0,-1,-1,1,0,1),(-1,-1,-1,0,1,0)),
       ((-1,-1,0,-1,0,1),(-1,0,1,0,1,-1),(0,-1,0,1,1,1),(-1,0,1,0,-1,1)),
       ((0,-1,0,1,1,0),(0,1,-1,0,1,0),(0,1,0,-1,-1,0),(0,-1,-1,0,1,0)),
       ((0,1,-1,-1,-1,0),(0,-1,1,-1,-1,0),(0,1,-1,-1,-1,0),(0,-1,1,-1,-1,0)),
       ((0,1,1,0,1,-1),(0,1,-1,0,1,1),(0,1,1,0,1,-1),(0,1,-1,0,1,1)));

var
  Form1: TForm1;
  NowFigure,NextFigure:TFigureIndex;
  Matrix:array[1..10,1..20] of int;
  GameLever:byte;     //[0..10] 1..11
  GameStarted:boolean;
  KeyPressed:byte;   //     
  LinesCount:byte;   //   
  Lines:array[1..4] of byte;  //  Y-  
  Flashindex,BgSel,BrickSel:byte; //- ,  ,  
  GameOver:boolean;
implementation

uses Unit2;

{$R *.dfm}

Procedure TForm1.GetRem;
var
  Y,X:integer;
  Bg_P,Mask_P,Rem_P 	 : PByteArray;
  r:trect;
  BG:Tbitmap;
begin
 Bg:=TBitmap.Create;
 bg.PixelFormat:=pf24Bit;
 bg.Width:=ImageList1.Items.Item[10].picture.width;
 bg.Height:=ImageList1.Items.Item[10].picture.Height;
 bg.Canvas.Draw(-5,0,BgList.Items.Item[3].picture.graphic);
 RemBmp.Assign(ImageList1.Items.Item[10].picture.bitmap);
 for Y := 0 to RemBmp.Height -1 do
 begin
   Mask_P := ImageList1.Items.Item[11].picture.bitmap.ScanLine[y];
   BG_P   := Bg.ScanLine[y];
   Rem_P  := RemBmp.ScanLine[y];
   for X:=0 to (3*RemBmp.Width)-1 do
   begin
     Rem_P[x]:=Rem_P[x]+muldiv(100,255-Mask_P[x],255) *(Bg_P[x]-Rem_P[x]) div 100;
   end;
 end;
 bg.Free;
end;

procedure TForm1.DXTimer1Activate(Sender: TObject);
begin
  Draw; //   
end;

procedure TForm1.Draw;
var
  x,y,n:integer;
begin
  if not DXDraw1.CanDraw then exit;
  //  
  for y := 0 to Dxdraw1.Height div BgList.Items.Item[3].Picture.Height do
    for x := 0 to Dxdraw1.Width div BgList.Items.Item[3].Picture.Width do
       DxDraw1.Surface.Canvas.Draw(x*BgList.Items.Item[3].Picture.Width,y*BgList.Items.Item[3].Picture.Height,BgList.Items.Item[3].picture.graphic);
  //   
  DxDraw1.Surface.Canvas.Draw(5,0,RemBmp);
  // 
  for y:=0 to  DxDraw1.Height div 2 do
  begin
    DxDraw1.Surface.Canvas.Draw(0,y*2,ImageList1.Items.Item[4].picture.bitmap);
    DxDraw1.Surface.Canvas.Draw(dxdraw1.Width-7,y*2,ImageList1.Items.Item[0].picture.bitmap);
  end;

  For x:=0 to DxDraw1.Width div 2 do
    DxDraw1.Surface.Canvas.Draw(x*2,DxDraw1.Height-7,ImageList1.Items.Item[2].picture.bitmap);
  DxDraw1.Surface.Canvas.Draw(0,DxDraw1.Height-7,ImageList1.Items.Item[3].picture.bitmap);
  DxDraw1.Surface.Canvas.Draw(dxdraw1.Width-7,DxDraw1.Height-7,ImageList1.Items.Item[1].picture.bitmap);

  // 
  if GameStarted then
  begin
    DxDraw1.Surface.Canvas.Draw((Nowfigure.X*25)+7,Nowfigure.y*25,Bricklist.Items.Item[BrickSel].picture.bitmap);
    for n:=1 to 3 do
    begin
      x:=(Figure[Nowfigure.Fig,Nowfigure.Ras,(n*2)-1] + Nowfigure.X)*25;
      y:=(Figure[Nowfigure.Fig,Nowfigure.Ras,n*2] + Nowfigure.Y)*25;
      DxDraw1.Surface.Canvas.Draw(x+7,y,Bricklist.Items.Item[BrickSel].picture.bitmap);
    end;
    for y:=1 to 20 do
    for x:=1 to 10 do
      if matrix[x,y] > 0 then
         DxDraw1.Surface.Canvas.Draw(((x-1)*25)+7,(y-1)*25,Bricklist.Items.Item[BrickSel+1].picture.bitmap);
  end;
  //  GameOver
  if GameOver then
  begin
    DxDraw1.Surface.Canvas.Draw(16,200,imagelist1.Items.Item[9].picture.bitmap);
    GameStarted:=false;
  end;  
  //    
  DXDraw1.Surface.Canvas.Release;
  DXDraw1.Flip;
end;

procedure TForm1.SetBmpNextFigure;  //  
var
  x,y,n:integer;
  bmp:tbitmap;
begin;
  bmp:=tbitmap.Create;
  bmp.Width:=100;
  bmp.Height:=100;
  bmp.Canvas.Brush.Style:=bsSolid;
  bmp.Canvas.Brush.Color:=clblack;
  bmp.Canvas.FillRect(rect(0,0,100,100));
  bmp.Canvas.Draw(25,25,Bricklist.Items.Item[BrickSel].picture.graphic);
  for n:=1 to 3 do
  begin
    x:=(Figure[Nextfigure.Fig,Nextfigure.Ras,(n*2)-1] + 1)*25;
    y:=(Figure[Nextfigure.Fig,Nextfigure.Ras,n*2] + 1)*25;
    bmp.Canvas.Draw(x,y,Bricklist.Items.Item[BrickSel].picture.graphic);
  end;
  NextFigureImage.Picture.Bitmap.Assign(bmp);
  bmp.Free;
  NextFigureImage.Repaint;
end;

//  
procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
  MoveFigure;   //  
  Draw;         //
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  ini:tinifile;
  BgF:string;
begin
  GameLever:=0;
  GameStarted:=false;
  BGList.Items.Item[3].Picture.assign(BGList.Items.Item[0].Picture);
  BrickSel:=0;
  RemBmp:=Tbitmap.create;
  RemBmp.PixelFormat:=pf24Bit;
  //     
  if fileexists(ExtractFilepath(application.ExeName)+'Setup.ini') then
  begin
    ini:=tinifile.Create(ExtractFilepath(application.ExeName)+'Setup.ini');
    BgF:=ini.ReadString('Set','BgFn','');
    BgSel:=ini.ReadInteger('Set','BgSel',0);
    BrickSel:=ini.ReadInteger('Set','BrickSel',0);
    RecordLabel.Caption:=ini.ReadString('Set','Record','000');
    ini.Free;

    if BgF <> '' then
      try BgList.Items.Item[3].Picture.loadFromFile(BgF) except end else
          BgList.Items.Item[3].Picture.assign(BgList.Items.Item[BgSel].Picture);
    GetRem;
  end;

end;

procedure TForm1.SpeedButtonCep1Click(Sender: TObject);   // 
var
  n,m:integer;
begin
  for n:=1 to 20 do
  for m:=1 to 10 do
    Matrix[m,n]:=0;     //     
  CountLabel.Caption:='000';
  LinesLabel.Caption:='000';
  Randomize;     //
  NowFigure.Fig:=Random(7)+1;
  NowFigure.Ras:=random(4)+1;
  NowFigure.X:=4;
  NowFigure.Y:=0;
  For n:=1 to 3 do
    if Figure[NowFigure.Fig,NowFigure.Ras,n*2] < 0 then    //   
    begin
      NowFigure.Y:=1;
      break;
    end;


  NextFigure.Fig:=Random(7)+1;
  NextFigure.Ras:=random(4)+1;
  SetBmpNextFigure;
  GameLever:=0;
  LeverLabel.Caption:='1';
  GameStarted:=true;
  DxTimer1.Interval:=1100;
  DxTimer1.Enabled:=true;
  GameOver:=false;
  draw;
end;

procedure TForm1.SpeedButtonCep2Click(Sender: TObject);  // 
begin
  if not GameStarted then exit;
  Dxtimer1.Enabled:= not Dxtimer1.Enabled;
end;

procedure TForm1.MoveFigure; // 
var
  n:integer;
  StopMove:boolean; // 
begin;
  StopMove:=false;
  //          ,   
  if (NowFigure.Y = 19) or
     (matrix[NowFigure.X+1,NowFigure.Y+2] > 0) then StopMove:=true else
  for n := 1 to 3 do
  begin
    if NowFigure.Y+Figure[NowFigure.Fig,NowFigure.Ras,n*2] = 19 then
    begin
      StopMove:=true;
      Break;
    end;
    if matrix[NowFigure.X+Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1]+1,NowFigure.Y+Figure[NowFigure.Fig,NowFigure.Ras,n*2]+2] > 0 then
    begin
      StopMove:=true;
      Break;
    end;
  end;
  if StopMove then   //   :
  begin
    if SoundCB.Checked then DxWavelist1.Items.Items[0].Play(false);
    Matrix[NowFigure.X+1,NowFigure.Y+1]:=1;
    for n := 1 to 3 do
      matrix[NowFigure.X+Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1]+1,NowFigure.Y+Figure[NowFigure.Fig,NowFigure.Ras,n*2]+1]:=1;
    testmatrix; //    
    SetNewFigure;
  end else NowFigure.Y:=NowFigure.Y+1;
end;

procedure TForm1.TestMatrix;  //    
var
  y:integer;
begin
  linesCount:=0;
  for y:=1 to 20 do
   if matrix[1,y]+matrix[2,y]+matrix[3,y]+matrix[4,y]+matrix[5,y]+
      matrix[6,y]+matrix[7,y]+matrix[8,y]+matrix[9,y]+matrix[10,y] = 10 then
    begin
      linesCount:=linesCount+1;
      lines[linesCount]:=y;
    end;
  if linesCount > 0 then
  begin
    DxTimer1.Enabled:=false;  // 
    FlashIndex:=0;
    ClTimer.Enabled:=true;  //     ""  
  end;
end;

procedure TForm1.SetNewFigure;    //   
var
  n:integer;
begin
  NowFigure.Fig:=NextFigure.Fig;
  NowFigure.Ras:=NextFigure.Ras;
  NowFigure.X:=4;
  NowFigure.Y:=0;
  For n:=1 to 3 do
  begin
    if Figure[NowFigure.Fig,NowFigure.Ras,n*2] < 0 then
    begin
      NowFigure.Y:=1;
      break;
    end;
    //        
    if matrix[NowFigure.X+Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1]+1,NowFigure.y+Figure[NowFigure.Fig,NowFigure.Ras,n*2]+1] > 0 then
    begin
      GameOver:=true;
      DxTimer1.Enabled:=false;
      ClTimer.Enabled:=false;
      KbTimer.Enabled:=false;
      Draw;
      if SoundCB.Checked then DxWavelist1.Items.Items[3].Play(false);
      exit;
    end;
  end;
  Randomize;
  NextFigure.Fig:=Random(7)+1;
  NextFigure.Ras:=random(4)+1;
  SetBmpNextFigure;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not DxTimer1.Enabled then exit;
case integer(key) of
  37,39:if not KBTimer.Enabled then  begin  KeyPressed:=integer(key); KBTimer.Enabled:=true; KbMoveFigure; end;
  38,32:TurnFugure; // 
  40:if Dxtimer1.Interval > 70 then Dxtimer1.Interval := 70;
  27:close;
  112..118: if Gamestarted then begin  NextFigure.Fig:= integer(key)-111; SetBmpNextFigure; end;
end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not DxTimer1.Enabled then exit;
if integer(key) = 40 then
begin
 if GameLever < 10 then  DXTimer1.Interval:=1100-(GameLever*100)
 else DXTimer1.Interval:=90;
end; 
KBtimer.Enabled:=false;
end;

Procedure TForm1.KbMoveFigure;
var n:integer;
begin
//    
if KeyPressed = 37 then
begin
  if NowFigure.X <= 0 then exit;
  if matrix[NowFigure.X,NowFigure.Y+1] > 0 then exit;
  for n:=1 to 3 do
  begin
    if NowFigure.X + Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1] <= 0 then exit;
    if matrix[NowFigure.X + Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1],NowFigure.Y + Figure[NowFigure.Fig,NowFigure.Ras,n*2]+1] > 0 then exit;
  end;
  NowFigure.X:=NowFigure.X-1;
  draw;
end;
if KeyPressed = 39 then
begin
  if NowFigure.X >= 9 then exit;
  if matrix[NowFigure.X+2,NowFigure.Y+1] > 0 then exit;
  for n:=1 to 3 do
  begin
    if NowFigure.X + Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1] >= 9 then exit;
    if matrix[NowFigure.X + Figure[NowFigure.Fig,NowFigure.Ras,(n*2)-1]+2,NowFigure.Y + Figure[NowFigure.Fig,NowFigure.Ras,n*2]+1] > 0 then exit;
  end;
  NowFigure.X:=NowFigure.X+1;
  draw;
end;

end;

Procedure TForm1.TurnFugure; // 
var n,i:integer;
begin
i:=NowFigure.Ras+1;
if i > 4 then i:=1;
for n:=1 to 3 do
begin
 if matrix[NowFigure.X+figure[NowFigure.Fig,i,(n*2)-1]+1,NowFigure.Y+figure[NowFigure.Fig,i,n*2]+1] > 0 then exit;
 if NowFigure.Y+figure[NowFigure.Fig,i,n*2] >= 20 then exit;
 if NowFigure.X+figure[NowFigure.Fig,i,(n*2)-1] < 0 then NowFigure.X:=NowFigure.X+1;
 if NowFigure.X+figure[NowFigure.Fig,i,(n*2)-1] > 9 then NowFigure.X:=NowFigure.X-1;
end;
if SoundCB.Checked then DxWavelist1.Items.Items[1].Play(false);
NowFigure.Ras:=i;
draw;
end;

procedure TForm1.KBTimerTimer(Sender: TObject);
begin
KbMoveFigure;  //     
end;

procedure TForm1.CLTimerTimer(Sender: TObject);//     ""  
var x,y,n:integer;
begin
// 
if FlashIndex <= 6 then
begin
  case FlashIndex of
  0,2,4,6: for y:=1 to LinesCount do for x:=1 to 10 do matrix[x,Lines[y]]:=0;
  1,3,5: for y:=1 to LinesCount do for x:=1 to 10 do matrix[x,Lines[y]]:=1;
  end;
  Draw;
  FlashIndex:=FlashIndex+1;
  exit;
end;

//
if SoundCB.Checked then DxWavelist1.Items.Items[2].Play(false);
for n:=1 to LinesCount do
for y:=Lines[n]-1 Downto 1 do
for x:=1 to 10 do
  Matrix[x,y+1] := Matrix[x,y];
ClTimer.Enabled:=false;
Draw;
//   ,  ,      
LinesLabel.Caption:=inttostr(strtoint(LinesLabel.Caption)+ LinesCount);
if LinesCount = 1 then CountLabel.Caption:=inttostr(Strtoint(CountLabel.Caption)+100) else
                       CountLabel.Caption:=inttostr(Strtoint(CountLabel.Caption)+(linesCount*150));
if strtoint(CountLabel.Caption) > strtoint(RecordLabel.Caption) then RecordLabel.Caption := CountLabel.Caption;
if ((strtoint(LinesLabel.Caption) >= 20) and (strtoint(LinesLabel.Caption) < 40)) then GameLever:=1;
if ((strtoint(LinesLabel.Caption) >= 40) and (strtoint(LinesLabel.Caption) < 60))  then GameLever:=2;
if ((strtoint(LinesLabel.Caption) >= 60) and (strtoint(LinesLabel.Caption) < 80))  then GameLever:=3;
if ((strtoint(LinesLabel.Caption) >= 80) and (strtoint(LinesLabel.Caption) < 100))  then GameLever:=4;
if ((strtoint(LinesLabel.Caption) >= 100) and (strtoint(LinesLabel.Caption) < 120))  then GameLever:=5;
if ((strtoint(LinesLabel.Caption) >= 120) and (strtoint(LinesLabel.Caption) < 140))  then GameLever:=6;
if ((strtoint(LinesLabel.Caption) >= 140) and (strtoint(LinesLabel.Caption) < 180))  then GameLever:=7;
if ((strtoint(LinesLabel.Caption) >= 180) and (strtoint(LinesLabel.Caption) < 240))  then GameLever:=8;
if ((strtoint(LinesLabel.Caption) >= 240) and (strtoint(LinesLabel.Caption) < 280))  then GameLever:=9;
if ((strtoint(LinesLabel.Caption) >= 280) and (strtoint(LinesLabel.Caption) < 320))  then GameLever:=10;

LeverLabel.Caption:=inttostr(GameLever+1);
if GameLever < 10 then DXTimer1.Interval:=1100-(GameLever*100) else DXTimer1.Interval:=90;
DxTimer1.Enabled:=true;
end;

procedure TForm1.SpeedButtonCep3Click(Sender: TObject);  //   
begin
Dxtimer1.Enabled:=false;
SetupForm.ShowModal;
if GameStarted and (not GameOver) then Dxtimer1.Enabled:=true ;
end;

procedure TForm1.SpeedButtonCep4Click(Sender: TObject);   // 
var ini:tinifile;
    Y,x:INTEGER;
    s,bgFN:string;
begin
  if not GameStarted then exit;
  Dxtimer1.Enabled:= false;
  if SaveDialog1.Execute then
  begin
    ini:=tinifile.Create(SaveDialog1.FileName);     //    INI 
    for y:=1 to 20 do
    begin
      s:='';
      for x:=1 to 10 do s:=s+inttostr(matrix[x,y]);
      ini.WriteString('Matrix',inttostr(y),s);
    end;
    ini.WriteInteger('Set','GameLever',GameLever);
    ini.WriteString ('Set','Count',CountLabel.Caption);
    ini.WriteString ('Set','Lines',LinesLabel.Caption);
    ini.WriteInteger('NowFigure','Fig',NowFigure.Fig);
    ini.WriteInteger('NowFigure','Ras',NowFigure.Ras);
    ini.WriteInteger('NowFigure','X',NowFigure.X);
    ini.WriteInteger('NowFigure','y',NowFigure.Y);
    ini.WriteInteger('NextFigure','Fig',NextFigure.Fig);
    ini.WriteInteger('NextFigure','Ras',NextFigure.Ras);
    ini.Free;
  end;
    Dxtimer1.Enabled:= true;

end;

procedure TForm1.SpeedButtonCep5Click(Sender: TObject);   // 
var ini:tinifile;
    Y,x,n:INTEGER;
    s,bgFN:string;
begin
  if GameStarted then Dxtimer1.Enabled:= false;
  if OpenDialog1.Execute then
  begin
    Randomize;
    NowFigure.Fig:=Random(7)+1;
    NowFigure.Ras:=random(4)+1;
    NowFigure.X:=4;
    NowFigure.Y:=0;
    For n:=1 to 3 do
      if Figure[NowFigure.Fig,NowFigure.Ras,n*2] < 0 then
      begin
        NowFigure.Y:=1;
        break;
      end;
    NextFigure.Fig:=Random(7)+1;
    NextFigure.Ras:=random(4)+1;

    ini:=tinifile.Create(OpenDialog1.FileName);
    for y:=1 to 20 do
    begin
      s:=ini.ReadString('Matrix',inttostr(y),'0000000000');
      for x:=1 to 10 do matrix[x,y]:=strtoint(s[x]);
    end;
    GameLever:=ini.ReadInteger('Set','GameLever',0);
    LeverLabel.Caption:=inttostr(GameLever+1);
    CountLabel.Caption:=ini.ReadString ('Set','Count','000');
    LinesLabel.Caption:=ini.ReadString ('Set','Lines','000');
    NowFigure.Fig:=ini.ReadInteger('NowFigure','Fig',NowFigure.Fig);
    NowFigure.Ras:=ini.ReadInteger('NowFigure','Ras',NowFigure.Ras);
    NowFigure.X:=ini.ReadInteger('NowFigure','X',NowFigure.X);
    NowFigure.Y:=ini.ReadInteger('NowFigure','y',NowFigure.Y);
    NextFigure.Fig:=ini.ReadInteger('NextFigure','Fig',NextFigure.Fig);
    NextFigure.Ras:=ini.ReadInteger('NextFigure','Ras',NextFigure.Ras);
    ini.Free;
  end;
  SetBmpNextFigure;
  GameStarted:=true;
  if GameLever < 10 then DXTimer1.Interval:=1100-(GameLever*100) else DXTimer1.Interval:=90;
  DxTimer1.Enabled:=true;
  GameOver:=false;
  draw;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var ini:tinifile;
begin
  ini:=tinifile.Create(ExtractFilepath(application.ExeName)+'Setup.ini');
  ini.WriteString('Set','Record',RecordLabel.Caption);
  ini.Free;
  RemBmp.free;
end;

end.
