unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MyImage, StdCtrls, Buttons, ExtCtrls, ExtDlgs,jpeg, FileCtrl,inifiles;

type
  TSetupForm = class(TForm)
    GroupBox1: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Shape1: TShape;
    Image1: TImage;
    Shape2: TShape;
    Image2: TImage;
    Shape3: TShape;
    Image3: TImage;
    SpeedButton3: TSpeedButton;
    OPDialog: TOpenPictureDialog;
    ScrollBar1: TScrollBar;
    CheckBox1: TCheckBox;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    GroupBox2: TGroupBox;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Image8: TImage;
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Bg1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bg2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bg3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Shape4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetupForm: TSetupForm;
  bgs,brs:integer;
  imgCanSel:array[1..3] of boolean;
  BgFn:string;
implementation

uses Unit1;

{$R *.dfm}

procedure TSetupForm.FormShow(Sender: TObject);
begin
bgs:=BgSel;
brs:=BrickSel;
Shape1.Pen.Color:=clNavy;
Shape1.Pen.Width:=2;
Shape2.Pen.Color:=clNavy;
Shape2.Pen.Width:=2;
Shape3.Pen.Color:=clNavy;
Shape3.Pen.Width:=2;
Shape4.Pen.Color:=clNavy;
Shape4.Pen.Width:=2;
Shape5.Pen.Color:=clNavy;
Shape5.Pen.Width:=2;
Shape6.Pen.Color:=clNavy;
Shape6.Pen.Width:=2;
Shape7.Pen.Color:=clNavy;
Shape7.Pen.Width:=2;
Shape8.Pen.Color:=clNavy;
Shape8.Pen.Width:=2;
if BrickSel = 0 then
begin
  Shape4.Pen.Color:=claqua;
  Shape4.Pen.Width:=3;
end;
if BrickSel = 2 then
begin
  Shape5.Pen.Color:=claqua;
  Shape5.Pen.Width:=3;
end;
if BrickSel = 4 then
begin
  Shape6.Pen.Color:=claqua;
  Shape6.Pen.Width:=3;
end;
if BrickSel = 6 then
begin
  Shape7.Pen.Color:=claqua;
  Shape7.Pen.Width:=3;
end;
if BrickSel = 8 then
begin
  Shape8.Pen.Color:=claqua;
  Shape8.Pen.Width:=3;
end;

if BgSel = 0 then
begin
  Shape1.Pen.Color:=clAqua;
  Shape1.Pen.Width:=3;
end;
if BgSel = 1 then
begin
  Shape2.Pen.Color:=clAqua;
  Shape2.Pen.Width:=3;
end;
if BgSel = 2 then
begin
  Shape3.Pen.Color:=clAqua;
  Shape3.Pen.Width:=3;
end;


end;

procedure TSetupForm.SpeedButton1Click(Sender: TObject);
var ini:tinifile;
begin
BgSel:=BGS;
BrickSel:=BrS;

ini:=tinifile.Create(ExtractFilepath(application.ExeName)+'Setup.ini');
ini.WriteString('Set','BgFn',BgFn);
ini.WriteInteger('Set','BgSel',BgSel);
ini.WriteInteger('Set','BrickSel',BrickSel);
ini.Free;

if BgSel = 0 then
 form1.BGlist.Items.Item[3].Picture.assign(image1.Picture);
if BgSel = 1 then
 form1.BGlist.Items.Item[3].Picture.assign(image2.Picture);
if BgSel = 2 then
 form1.BGlist.Items.Item[3].Picture.assign(image3.Picture);

Form1.GetRem;
form1.Draw;

modalresult:=1;
end;

procedure TSetupForm.SpeedButton2Click(Sender: TObject);
begin
modalresult:=2;
end;

procedure TSetupForm.Bg1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if not imgCanSel[1] then exit;
Shape2.Pen.Color:=clNavy;
Shape2.Pen.Width:=2;
Shape3.Pen.Color:=clNavy;
Shape3.Pen.Width:=2;
Shape1.Pen.Color:=clAqua;
Shape1.Pen.Width:=3;
BGS:=0;
if Scrollbar1.Position = 0 then BgFn:='' else
  BgFn:=DirectoryListbox1.Directory+'\'+FileListBox1.Items.Strings[(Scrollbar1.position-1)*3];
end;

procedure TSetupForm.bg2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if not imgCanSel[2] then exit;
Shape1.Pen.Color:=clNavy;
Shape1.Pen.Width:=2;
Shape3.Pen.Color:=clNavy;
Shape3.Pen.Width:=2;
Shape2.Pen.Color:=clAqua;
Shape2.Pen.Width:=3;
BGS:=1;
if Scrollbar1.Position = 0 then BgFn:='' else
  BgFn:=DirectoryListbox1.Directory+'\'+FileListBox1.Items.Strings[((Scrollbar1.position-1)*3)+1];
end;

procedure TSetupForm.bg3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if not imgCanSel[3] then exit;
Shape2.Pen.Color:=clNavy;
Shape2.Pen.Width:=2;
Shape1.Pen.Color:=clNavy;
Shape1.Pen.Width:=2;
Shape3.Pen.Color:=clAqua;
Shape3.Pen.Width:=3;
BGS:=2;
if Scrollbar1.Position = 0 then BgFn:='' else
  BgFn:=DirectoryListbox1.Directory+'\'+FileListBox1.Items.Strings[((Scrollbar1.position-1)*3)+2];
end;

procedure TSetupForm.SpeedButton3Click(Sender: TObject);
begin
if OPdialog.Execute then
begin
   form1.BgList.Items.Item[3].Picture.LoadFromFile(OPdialog.FileName);
   BgFn:=OPdialog.FileName;
   BgS:=-1;
end;
end;

procedure TSetupForm.CheckBox1Click(Sender: TObject);
begin
image1.Proportional:=checkbox1.Checked;
image2.Proportional:=checkbox1.Checked;
image3.Proportional:=checkbox1.Checked;
end;

procedure TSetupForm.FormCreate(Sender: TObject);
var d:string;
    n:integer;
begin
d:=ExtractFilePath(application.ExeName)+'images\';
if DirectoryExists(d) then
begin
  DirectoryListBox1.Directory:=d;
  FileListBox1.Update;
  if FileListBox1.Items.Count > 0 then
  begin
   ScrollBar1.Enabled:=true;
   ScrollBar1.Max:=Round(FileListBox1.Items.Count/3)+1;
 //  ScrollBar1.PageSize:=ScrollBar1.Max;
  end;
end;
for n:=1 to 3 do imgCanSel[n]:=true;
end;

procedure TSetupForm.ScrollBar1Change(Sender: TObject);
var n:integer;
begin
  Shape1.Pen.Color:=clNavy;
  Shape1.Pen.Width:=2;
  Shape2.Pen.Color:=clNavy;
  Shape2.Pen.Width:=2;
  Shape3.Pen.Color:=clNavy;
  Shape3.Pen.Width:=2;
  BGS:=-1;
  if ScrollBar1.Position = 0 then
  begin
    image1.Picture.Assign(Form1.BGlist.Items.Item[0].picture);
    image2.Picture.Assign(Form1.BGlist.Items.Item[1].picture);
    image3.Picture.Assign(Form1.BGlist.Items.Item[2].picture);
    for n:=1 to 3 do imgCanSel[n]:=true;
    exit;
  end;
  try
    image1.Picture.LoadFromFile(DirectoryListbox1.Directory+'\'+FileListBox1.Items.Strings[(Scrollbar1.position-1)*3]);
    imgCanSel[1]:=true;
  except
    image1.Picture:=nil;
    imgCanSel[1]:=false;
  end;
  try
    image2.Picture.LoadFromFile(DirectoryListbox1.Directory+'\'+FileListBox1.Items.Strings[((Scrollbar1.position-1)*3)+1]);
    imgCanSel[2]:=true;
  except
    image2.Picture:=nil;
    imgCanSel[2]:=false;
  end;
  try
    image3.Picture.LoadFromFile(DirectoryListbox1.Directory+'\'+FileListBox1.Items.Strings[((Scrollbar1.position-1)*3)+2]);
    imgCanSel[3]:=true;
  except
    image3.Picture:=nil;
    imgCanSel[3]:=false;
  end;

end;

procedure TSetupForm.Shape4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Shape4.Pen.Color:=clNavy;
Shape4.Pen.Width:=2;
Shape5.Pen.Color:=clNavy;
Shape5.Pen.Width:=2;
Shape6.Pen.Color:=clNavy;
Shape6.Pen.Width:=2;
Shape7.Pen.Color:=clNavy;
Shape7.Pen.Width:=2;
Shape8.Pen.Color:=clNavy;
Shape8.Pen.Width:=2;
with TShape(Sender) do
begin
  BRS:=tag;
  Pen.Color:=clAqua;
  Pen.Width:=3;
end;
end;

end.
